using System;
using System.Collections;
using System.Reflection;
using System.Runtime.Remoting;
using System.IO;
using Kodama.DependencyInjection.Container;
using Kodama.DependencyInjection.Marker;

namespace Kodama.DependencyInjection.Builder
{
    /// <summary>
    /// IɁADependencyInjectionRei𐶐
    /// R|[lgo^ÃCX^XԂr_
    /// </summary>
    public class AutoComponentContainerBuilder : IComponentContainerBuilder
    {
        /// <summary>
        /// o^R|[lg̃JeS
        /// </summary>
        private string componentCategory = "";

        /// <summary>
        /// o^AZu
        /// </summary>
        private ArrayList assemblies = new ArrayList();

        /// <summary>
        /// o^R|[lg̃JeS
        /// </summary>
        public string ComponentCategory
        {
            get { return componentCategory; }
            set { componentCategory = value; }
        }

        /// <summary>
        /// o^AZuǉ
        /// </summary>
        /// <param name="assemblyName">o^AZůS</param>
        public void AddAssemblyFile(AssemblyName assemblyName)
        {
            assemblies.Add(Assembly.Load(assemblyName));
        }

        /// <summary>
        /// o^AZuǉ
        /// </summary>
        /// <param name="filename">o^AZũt@C</param>
        public void AddAssemblyFile(string filename)
        {
            assemblies.Add(Assembly.LoadFile(filename));
        }

        /// <summary>
        /// o^AZuǉ
        /// </summary>
        /// <param name="folder">o^AZu܂܂tH_</param>
        public void AddAssemblyFolder(string folder)
        {
            foreach (string name in Directory.GetFiles(folder, "*.dll"))
            {
                assemblies.Add(Assembly.LoadFile(Path.Combine(folder, name)));
            }
        }

        /// <summary>
        /// o^郊[eBOIuWFNg܂ރAZuǉ
        /// </summary>
        /// <param name="filename">[eBOIuWFNgɂċLqݒt@C̃pX</param>
        /// <seealso cref="System.Runtime.Remoting.RemotingConfiguration">RemotingConfigurationNX</seealso>
        public static void RemotingConfigure(string filename)
        {
            RemotingConfiguration.Configure(filename);
        }

        /// <summary>
        /// IɁADependencyInjectionRei𐶐
        /// R|[lgo^ÃCX^XԂ
        /// </summary>
        /// <returns>ꂽDependencyInjectionRei</returns>
        public IComponentContainer Build()
        {
            // AZuAutoRegistrationAssemblyݒ肳Ă̂Iʂ
            ArrayList filteredAssemblies = new ArrayList();
            foreach (Assembly assembly in assemblies)
            {
                if (Attribute.IsDefined(assembly, typeof(AutoRegistrationAssemblyAttribute)))
                {
                    filteredAssemblies.Add(assembly);
                }
            }

            // ReĩCX^X̐
            IMutableComponentContainer container = new ComponentContainerImpl();

            // IʂꂽAZuAutoRegistrationComponentݒ肳Ă̂Reiɓo^
            foreach (Assembly assembly in filteredAssemblies)
            {
                foreach (Type type in assembly.GetTypes())
                {
                    if (Attribute.IsDefined(type, typeof(AutoRegistratonComponentAttribute)))
                    {
                        AutoRegistratonComponentAttribute aca =
                            (AutoRegistratonComponentAttribute)Attribute.GetCustomAttribute
                            (type, typeof(AutoRegistratonComponentAttribute));
                        if (string.Compare(aca.ComponentCategory, componentCategory, true) == 0)
                        {
                            aca.Register(container, type);
                        }
                    }
                }
            }

            // [eBOIuWFNg̓o^
            foreach (ActivatedClientTypeEntry entry in RemotingConfiguration.GetRegisteredActivatedClientTypes())
            {
                if (Attribute.IsDefined(entry.ObjectType, typeof(AutoRegistratonComponentAttribute)))
                {
                    AutoRegistratonComponentAttribute aca =
                        (AutoRegistratonComponentAttribute)Attribute.GetCustomAttribute
                        (entry.ObjectType, typeof(AutoRegistratonComponentAttribute));
                    if (string.Compare(aca.ComponentCategory, componentCategory, true) == 0)
                    {
                        aca.Register(container, entry.ObjectType);
                    }
                }
            }
            foreach (ActivatedServiceTypeEntry entry in RemotingConfiguration.GetRegisteredActivatedServiceTypes())
            {
                if (Attribute.IsDefined(entry.ObjectType, typeof(AutoRegistratonComponentAttribute)))
                {
                    AutoRegistratonComponentAttribute aca =
                        (AutoRegistratonComponentAttribute)Attribute.GetCustomAttribute
                        (entry.ObjectType, typeof(AutoRegistratonComponentAttribute));
                    if (string.Compare(aca.ComponentCategory, componentCategory, true) == 0)
                    {
                        aca.Register(container, entry.ObjectType);
                    }
                }
            }
            foreach (WellKnownClientTypeEntry entry in RemotingConfiguration.GetRegisteredWellKnownClientTypes())
            {
                if (Attribute.IsDefined(entry.ObjectType, typeof(AutoRegistratonComponentAttribute)))
                {
                    AutoRegistratonComponentAttribute aca =
                        (AutoRegistratonComponentAttribute)Attribute.GetCustomAttribute
                        (entry.ObjectType, typeof(AutoRegistratonComponentAttribute));
                    if (string.Compare(aca.ComponentCategory, componentCategory, true) == 0)
                    {
                        aca.Register(container, entry.ObjectType);
                    }
                }
            }
            foreach (WellKnownServiceTypeEntry entry in RemotingConfiguration.GetRegisteredWellKnownServiceTypes())
            {
                if (Attribute.IsDefined(entry.ObjectType, typeof(AutoRegistratonComponentAttribute)))
                {
                    AutoRegistratonComponentAttribute aca =
                        (AutoRegistratonComponentAttribute)Attribute.GetCustomAttribute
                        (entry.ObjectType, typeof(AutoRegistratonComponentAttribute));
                    if (string.Compare(aca.ComponentCategory, componentCategory, true) == 0)
                    {
                        aca.Register(container, entry.ObjectType);
                    }
                }
            }

            return container;
        }
    }
}
