using System;
using System.Collections;
using Kodama.Function.Functor;

namespace Kodama.Function.Functor.Bind
{
    /// <summary>
    /// ̊֐IuWFNg̈oCh֐IuWFNgł
    /// </summary>
    /// <remarks>
    /// C++łSTL/Boostbindɑ܂B
    /// </remarks>
    /// <example>
    /// <code lang="C#">
    /// 
    /// public class TestClass1
    /// {
    ///     public void Print(string arg1, string arg2, object arg3, string arg4)
    ///     {
    ///         Console.WriteLine(arg1);
    ///         Console.WriteLine(arg2);
    ///         Console.WriteLine(arg3.ToString());
    ///         Console.WriteLine(arg4);
    ///     }
    /// }
    ///
    /// public class TestClass2
    /// {
    ///     public override string ToString()
    ///     {
    ///         return "3";
    ///     }
    /// }
    ///
    /// // ̊֐ĂԂƁAR\["1"A"2"A"3"A"4"4s\܂
    /// public void BindFunctorTest()
    /// {
    ///     // oChΏۂMemberFunctor𐶐
    ///     IFunctor memberFunctor = new MemberFunctor(typeof(TestClass1).GetMethod("Print"));
    ///
    ///     // BindFunctor𐶐B̂Ƃ̃oChs
    ///     IFunctor bindFunctor = new BindFunctor(
    ///         // oChMemberFunctor
    ///         memberFunctor,
    ///         // methodFunctoȓ1̓oChȂ̎w
    ///         new NotBoundArgument(0),
    ///         // methodFunctoȓ2oCh
    ///         "1",
    ///         // methodFunctoȓ3̓oChȂ̎w
    ///         new NotBoundArgument(1),
    ///         // BindFunctor#InvokeɐVTestClass2̃CX^XoCh
    ///         BindUtility.Create(typeof(TestClass2), null), 
    ///         // methodFunctoȓ5oCh
    ///         "4"});
    ///
    ///     // ֐IuWFNǧĂяo
    ///     // ŃoChĂȂn܂
    ///     bindFunctor.Invoke(new TestClass1(), "2");
    /// }
    /// </code>
    /// </example>
    /// <seealso href="http://boost.cppll.jp/HEAD/">Boostt@X{</seealso>
    public class BindFunctor : IFunctor
    {
        /// <summary>
        /// oCh֐IuWFNg
        /// </summary>
        private IFunctor internalFunctor;

        /// <summary>
        /// oChꂽ
        /// </summary>
        private object[] boundArguments;

        /// <summary>
        /// ֐IuWFNgfQ[gɕϊĕԂ
        /// </summary>
        /// <returns>֐IuWFNgϊꂽfQ[g</returns>
        public FunctorHandler ConvertToDelegate()
        {
            return new FunctorHandler(Invoke);
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="functor">oCh֐IuWFNg</param>
        /// <param name="arguments">oCh</param>
        public BindFunctor(IFunctor functor, params object[] arguments)
        {
            internalFunctor = functor;
            boundArguments  = arguments;
        }

        /// <summary>
        /// oChꂽԂ܂
        /// </summary>
        /// <returns>oChꂽ</returns>
        public object[] GetBoundArguments()
        {
            return boundArguments;
        }

        /// <summary>
        /// ֐IuWFNǧĂяo
        /// </summary>
        /// <returns>֐IuWFNg̖̏߂l</returns>
        /// <exception cref="UnmatchArgumentException">̐ƌ^Ȃꍇ̗͂O𓊂</exception>
        public object Invoke()
        {
            ArrayList list = new ArrayList();
            foreach (object arg in boundArguments)
            {
                if (arg is NotBoundArgument)
                {
                    throw new UnmatchArgumentException();
                }

                IArgumentProvider provider = arg as IArgumentProvider;
                if (provider != null)
                {
                    list.Add(provider.Provide());
					continue;
                }

                list.Add(arg);
            }
            return internalFunctor.Invoke(list.ToArray());
        }

        /// <summary>
        /// ֐IuWFNǧĂяo
        /// </summary>
        /// <param name="arguments">֐IuWFNg̏̈</param>
        /// <returns>֐IuWFNg̖̏߂l</returns>
        /// <exception cref="UnmatchArgumentException">̐ƌ^Ȃꍇ̗͂O𓊂</exception>
        public object Invoke(params object[] arguments)
        {
            ArrayList list = new ArrayList();
            foreach (object arg in boundArguments)
            {
                NotBoundArgument notBoundArgument = arg as NotBoundArgument;
                if (notBoundArgument != null)
                {
                    if (arguments.Length <= notBoundArgument.Index)
                    {
                        throw new UnmatchArgumentException();
                    }
                    list.Add(arguments[notBoundArgument.Index]);
                    continue;
                }

                IArgumentProvider provider = arg as IArgumentProvider;
                if (provider != null)
                {
	                list.Add(provider.Provide());
	                continue;
                }

                list.Add(arg);
            }
            return internalFunctor.Invoke(list.ToArray());
        }
	}
}
